Normix
Date: 2019-10-22

org.jmol.util

## Class Normix

- java.lang.Object
- - org.jmol.util.Normix

-     public class Normix
      extends java.lang.Object

  Provides quantization of normalized vectors so that shading for lighting calculations can be handled by a simple index lookup

  A 'normix' is a normal index, represented as a short

  Author:
    Miguel, miguel@jmol.org

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static short[]` | `inverseNormixes`
    `private static short[][]` | `neighborVertexesArrays`
    `private static int` | `NORMIX_GEODESIC_LEVEL`
    `static short` | `NORMIX_NULL`
    `private static short` | `normixCount`
    `private static javajs.util.V3[]` | `vertexVectors`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Normix()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static short` | `get2SidedNormix(javajs.util.V3 v, javajs.util.BS bsTemp)`
    `static short` | `getInverseNormix(short normix)`
    `private static short[][]` | `getNeighborVertexArrays()`
    `private static short` | `getNormix(double x, double y, double z, int geodesicLevel, javajs.util.BS bsConsidered)`
    `static short` | `getNormixCount()`
    `static short` | `getNormixV(javajs.util.V3 v, javajs.util.BS bsTemp)`
    `static javajs.util.V3[]` | `getVertexVectors()`
    `static javajs.util.BS` | `newVertexBitSet()`
    `static void` | `setInverseNormixes()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NORMIX_GEODESIC_LEVEL

          private static final int NORMIX_GEODESIC_LEVEL

      See Also:
        Constant Field Values

    - #### normixCount

          private static short normixCount

    - #### vertexVectors

          private static javajs.util.V3[] vertexVectors

    - #### inverseNormixes

          private static short[] inverseNormixes

    - #### neighborVertexesArrays

          private static short[][] neighborVertexesArrays

    - #### NORMIX_NULL

          public static final short NORMIX_NULL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Normix

          public Normix()

  - ### Method Detail

    - #### getNormixCount

          public static short getNormixCount()

    - #### newVertexBitSet

          public static javajs.util.BS newVertexBitSet()

    - #### getVertexVectors

          public static javajs.util.V3[] getVertexVectors()

    - #### setInverseNormixes

          public static void setInverseNormixes()

    - #### getInverseNormix

          public static short getInverseNormix(short normix)

    - #### getNeighborVertexArrays

          private static short[][] getNeighborVertexArrays()

    - #### getNormixV

          public static short getNormixV(javajs.util.V3 v,
                                         javajs.util.BS bsTemp)

    - #### get2SidedNormix

          public static short get2SidedNormix(javajs.util.V3 v,
                                              javajs.util.BS bsTemp)

    - #### getNormix

          private static short getNormix(double x,
                                         double y,
                                         double z,
                                         int geodesicLevel,
                                         javajs.util.BS bsConsidered)